// FullAccess
resource "azurerm_role_definition" "data_box_fullaccess_definition" {
  name              = "data-box-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.DataBox/register/action",
      "Microsoft.DataBox/jobs/cancel/action",
      "Microsoft.DataBox/jobs/bookShipmentPickUp/action",
      "Microsoft.DataBox/jobs/read",
      "Microsoft.DataBox/jobs/delete",
      "Microsoft.DataBox/jobs/write",
      "Microsoft.DataBox/jobs/listCredentials/action",
      "Microsoft.DataBox/locations/validateAddress/action",
      "Microsoft.DataBox/locations/availableSkus/action",
      "Microsoft.DataBox/locations/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/refresh/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/uploadCertificate/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/getExtendedInformation/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/scanForUpdates/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/downloadUpdates/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/installUpdates/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/networkSettings/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/securitySettings/update/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/updateSummary/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/jobs/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/alerts/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/alerts/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/operationsStatus/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/securitySettings/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/operationResults/read",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "data_box_readonly_definition" {
  name              = "data-box-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.DataBox/jobs/read",
      "Microsoft.DataBox/locations/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/networkSettings/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/updateSummary/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/jobs/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/alerts/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/alerts/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/operationsStatus/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/securitySettings/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/operationResults/read",
    ]

    not_actions = [
      "Microsoft.DataBox/register/action",
      "Microsoft.DataBox/jobs/cancel/action",
      "Microsoft.DataBox/jobs/bookShipmentPickUp/action",
      "Microsoft.DataBox/jobs/delete",
      "Microsoft.DataBox/jobs/write",
      "Microsoft.DataBox/jobs/listCredentials/action",
      "Microsoft.DataBox/locations/validateAddress/action",
      "Microsoft.DataBox/locations/availableSkus/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/refresh/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/uploadCertificate/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/getExtendedInformation/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/scanForUpdates/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/downloadUpdates/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/installUpdates/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/securitySettings/update/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "data_box_noaccess_definition" {
  name              = "data-box-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.DataBox/register/action",
      "Microsoft.DataBox/jobs/cancel/action",
      "Microsoft.DataBox/jobs/bookShipmentPickUp/action",
      "Microsoft.DataBox/jobs/read",
      "Microsoft.DataBox/jobs/delete",
      "Microsoft.DataBox/jobs/write",
      "Microsoft.DataBox/jobs/listCredentials/action",
      "Microsoft.DataBox/locations/validateAddress/action",
      "Microsoft.DataBox/locations/availableSkus/action",
      "Microsoft.DataBox/locations/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/refresh/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/uploadCertificate/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/getExtendedInformation/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/scanForUpdates/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/downloadUpdates/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/installUpdates/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/networkSettings/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/securitySettings/update/action",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/updateSummary/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/jobs/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/alerts/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/alerts/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/write",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/delete",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/operationsStatus/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/storageAccountCredentials/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/bandwidthSchedules/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/shares/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/users/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/securitySettings/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/roles/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/triggers/operationResults/read",
      "Microsoft.DataBoxEdge/dataBoxEdgeDevices/orders/operationResults/read",
    ]
  }
}
